# Representa a un grupo de alimentos, identificados por su nombre de grupo
# es una clase heredada de Alimento
#
# Author::    Alberto González  (mailto:alu0100949568@ull.edu.es)
# Copyright:: Cretive Commons
# License::   Distributes under the same terms as Ruby
class Alimento_concreto < Alimento
    # Se han incluido los mixin Comparable.
 	include Comparable
        def initialize(group_name, food_name, prot, gluc, lip)
            @group_name = group_name
            super(food_name, prot, gluc, lip)
        end
    # Devuelve de forma formateada el nombre del grupo al que pertenecen
    # un grupo de alimentos, además de los alimentos que lo conforman.
	def to_s
            "(#{@group_name} ->#{super.to_s})"
        end
	# Compara dos alimentos según su índice calórico
	def <=>(other)
	     return nil unless other.instance_of? Alimento_concreto
               @cal_index <=> other.cal_index
	end
end

