# encoding: utf-8
# Esta estructura respresenta a un nodo de nuestra futura
# lista. Tiene un nodo predecesor, sucesor y un valor.
#
# Author::    Alberto González  (mailto:alu0100949568@ull.edu.es)
# Copyright:: Cretive Commons
# License::   Distributes under the same terms as Ruby

Node = Struct.new(:value, :next, :prev)

# Representa una lista doblemente enlazada con una cabeza y una cola, 
# pudiéndose insertar un array de alimentos o alimentos individuales
#
# Author::    Alberto González  (mailto:alu0100949568@ull.edu.es)
# Copyright:: Cretive Commons
# License::   Distributes under the same terms as Ruby
class List
	# Se ha incluido el mixin Enumerable.
	include Enumerable
	# Se asigna la cabeza y cola a nil (inicialmente)
	def initialize
		@head = @tail = nil
	end
	# Método para insertar valores en la lista, se pueden
	# insertar varios valores o un único valor.
	def push(value)
		##Si es un array
	    if value.is_a?(Array)
	      value.each do |val|
	        prev = @tail unless @tail.nil?
	        while prev != @head do
	          prev = prev.next
        	end
    
	        node = Node.new(val, nil, prev)

	        @tail = node if @tail.nil?
	        @head.next = node unless @head.nil?
    
        	@head = node
	      end
	    else  #Si es un único valor
	      prev = @tail unless @tail.nil?
	        while prev != @head do
	          prev = prev.next
	        end
   
	        node = Node.new(value, nil, prev)
	
	        @tail = node if @tail.nil?
	        @head.next = node unless @head.nil?
    
	        @head = node
            end		
	end

	# Devuelve la cabeza de la lista a menos que no tenga cabeza
	def head
		@head.value unless @head.nil?
	end
	# Devuelve la cola de la lista a menos que no tenga cola
	def tail
		@tail.value unless @tail.nil?
	end
	# Borra la cola de la lista a menos que no tenga cola
	def remove_tail
		@tail = @tail.next unless @tail.nil?
	end
	# Borra la cabeza de la lista
	def remove_head
		@head = @head.prev
		@head.next = nil
	end
	# Muestra los valores que se han almacenado en la lista
	def to_s
            array = "["
	    next_val = @tail unless @tail.nil?
	      while next_val != nil do
	        array = array + next_val.value.to_s + ", "
	        next_val = next_val.next
        
	        if next_val == nil #For las element
	          array = array.chomp(', ') + "]"
	        end
	      end
	     	 "#{array}"
	end
	# Devuelve la cantidad de nodos que tiene nuestra lista
	def size
		count = 0 
		next_val = @tail unless @tail.nil?
		 while next_val != nil do
			next_val = next_val.next
			count +=1
		 end
		"#{count}"
	end
	# Método que nos permite recorrer cada uno de los nodos de nuestra lista
	def each
                next_val = @tail
                  while next_val != nil do
                        yield next_val.value
                        next_val = next_val.next
                  end
        end
	
end

