class Alimento
	attr_reader :nom, :prot, :gluc, :lip, :cal_index
		include Enumerable, Comparable
		# Se asigna el nombre y la información nutricional del alimento
		def initialize(nom, prot, gluc, lip, gluc_data = nil)
			@nom = nom
			@prot = prot
			@gluc = gluc
			@lip = lip
			@gluc_data = gluc_data
			@cal_index = (@prot.to_f*4 + @gluc.to_f*4 + @lip.to_f*9).round(2)
		end
		
		# Muestra la información de un alimento en concreto
		def to_s
			#El huevo frito tiene 14.1 proteinas, 0.0 glúcidos, 19.5 lípidos
			"%21s"%"#{@nom}:%13s "%" #{@prot} %13s "%" #{@gluc} %15s "%" #{@lip} %13s "%" #{@cal_index}"
		end		
		
		# Se comprueba que no sea un valor negativo, en caso de serlo, se sustituye por un 0
		def not_negative(n)
	            n < 0 ? n = 0 : n = n
	        end	
		
		# Calcula el área bajo la curva para los datos tomados en una medición de glucosa en intervalos de tiempo de 5 minutos
		def aibc
			@gluc_data.map{|indv| zero = indv.at(0); prev = -2; indv.map{|index| prev = prev + 1; ((index-zero) + (indv.at(not_negative(prev))-zero))*2.5}.reduce(:+).round(2)}
		end
	end